%numerical flux of the Godunov scheme for 1D scalar
%conservation laws with convex flux function

function value = F_G(u,v,s)
  %vectorized version (default)
  if(1)
    value = max(f(u),f(v) ) .* (v<u);
    value = value .* not(v<s & s<u)  + max(f(s),value) .* (v<s & s<u);
    value = value  + min(f(u),f(v)) .* (v>=u);
    value = value .* not(u<s & s<v)  + min(f(s),value) .* (u<s & s<v);

  %non-vectorized version
  else
    for i=1:length(u),
      if(v(i) < u(i)) value(i) = max( f(u(i)),f(v(i)) );
        if( v(i)<s & s<u(i) ) value(i) = max( f(s),value(i) ); end;
      else            value(i) = min( f(u(i)),f(v(i)) );
        if( u(i)<s & s<v(i) ) value(i) = min( f(s),value(i) ); end;
      end;
    end;
  end;